CREATE DATABASE `PatchMaker` ;

CREATE TABLE `Groups` (
  `GroupId` varchar(30) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `GroupCoords` (
  `GroupId` varchar(30) NOT NULL default '',
  `SectionGUID` int(10) NOT NULL default '0',
  `Top` varchar(10) NOT NULL default '0',
  `Left` varchar(10) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `Log` (
  `Date` date default NULL,
  `Time` time NOT NULL default '00:00:00',
  `UID` varchar(30) NOT NULL default '',
  `Event` varchar(255) NOT NULL default '',
  `SectionGUID` varchar(30) NOT NULL default '',
  `PortId` varchar(10) NOT NULL default '',
  `PatchSectionGUID` varchar(10) NOT NULL default '',
  `PatchPortId` varchar(10) NOT NULL default '',
  `Value` varchar(255) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `MapCoords` (
  `MapId` varchar(30) NOT NULL default '',
  `PortId` varchar(10) NOT NULL default '',
  `Top` varchar(10) NOT NULL default '',
  `Left` varchar(10) NOT NULL default '',
  `Rotation` char(3) NOT NULL default '',
  PRIMARY KEY  (`MapId`,`PortId`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `Maps` (
  `MapId` varchar(30) NOT NULL default '',
  `BackgroundPic` varchar(30) NOT NULL default '',
  `PortPic` varchar(30) NOT NULL default '',
  `PortUpPic` varchar(30) NOT NULL default '',
  `PortDownPic` varchar(30) NOT NULL default '',
  `PortUpXPic` varchar(30) NOT NULL default '',
  `PatchMakePic` varchar(30) NOT NULL default '',
  `PortNoDevicePic` varchar(30) NOT NULL default '',
  `TextStyle` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`MapId`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `Ports` (
  `SectionGUID` int(10) NOT NULL default '0',
  `PortId` int(10) NOT NULL default '0',
  `PatchSectionGUID` int(10) NOT NULL default '0',
  `PatchPortId` varchar(10) NOT NULL default '0',
  `RoomId` varchar(30) NOT NULL default '',
  `ClassId` varchar(30) NOT NULL default '',
  `Comment` varchar(100) NOT NULL default '',
  `LastSeen` longtext NOT NULL,
  PRIMARY KEY  (`SectionGUID`,`PortId`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `Sections` (
  `GUID` int(10) NOT NULL auto_increment,
  `BuildingId` varchar(30) NOT NULL default '',
  `RackId` varchar(30) NOT NULL default '',
  `SectionId` varchar(30) NOT NULL default '',
  `MapId` varchar(30) NOT NULL default '',
  `DeviceId` varchar(30) NOT NULL default '',
  `SlotId` varchar(10) NOT NULL default '',
  `StartingInterfaceId` varchar(10) NOT NULL default '',
  `PortCount` int(10) NOT NULL default '0',
  `CommId_get` varchar(30) NOT NULL default '',
  `CommId_set` varchar(30) NOT NULL default '',
  `GetMacAddresses` varchar(30) NOT NULL default '',
  `GetVlans` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`GUID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=167 ;

CREATE TABLE `Users` (
  `UID` varchar(64) NOT NULL default '',
  `UMask` int(255) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Set default admin user
--

INSERT INTO `Users` VALUES ('admin', 32767);

--
-- insert section
--

INSERT INTO `Sections` ( `GUID` , `BuildingId` , `RackId` , `SectionId` , `MapId` , `DeviceId` , `SlotId` , `StartingInterfaceId` , `PortCount` , `CommId_get` , `CommId_set` , `GetMacAddresses` , `GetVlans` ) 
VALUES ('1', 'Building', 'Rack', 'Section', '', '', '', '', '0', '', '', '', '');
