<?php
//********************************
//functions.php
//Miscellaneous functions.
//********************************
error_reporting (E_ERROR);
include ('DB.php');
$user = strip ($PHP_AUTH_USER);
function sqlStatement ($query)
{	global $conf,$error;
	$dbh = DB::connect ($conf[DB][connect]);
	if (!$dbh->connection)
	{	$error = $dbh->message;
		return false;
	}
	$result = $dbh->query ($query);
	if (preg_match ('/SELECT/',$query))
	{	$row = 0;
		while (!$end)
		{	$sql = $result->fetchRow (DB_FETCHMODE_ASSOC);
			switch ($sql)
			{	case false:
					$error = 'empty resultset';
					$end = true;
					break;
				default:
					foreach ($sql as $fieldname => $value)
					{	$resultset[$row][$fieldname] = $value;
					}
					break;
			}
			$row++;
		}
		if (preg_match ('/LIMIT 1/',$query)) $resultset = $resultset[0];

	}
	$dbh->disconnect;
	return $resultset;
}
function getStatusClass ($Port)# checks value of ifoperstatus from a port object and returns a class name
{	if (preg_match('/(1)|(up)/',$Port[snmp][ifEntry][ifOperStatus]))
	{	($Port[PatchSectionGUID] != 0)? $className = 'PortUp': $className = 'PortUpX';
	}else
	{	($Port[PatchSectionGUID] != 0)? $className = 'PortDown': $className = 'Port';
	}
	return $className;
}
function translateSpeed ($Speed)# translates port speed into easier to read format
{	$Speed = preg_replace ('/\A[A-Za-z0-9]*\: ||\r||\n||\'/', '', $Speed);
	switch ($Speed)
	{	case '1000000': $Speed='1M'; break;
		case '10000000': $Speed='10M'; break;
		case '100000000': $Speed='100M'; break;
		case '1000000000': $Speed='1G'; break;
	}
	return $Speed;
}
function echoError ($error)
{	echo "Error:<BR>\n";
	echo '<LI>'.$error."\n";
	exit;
}
function alertError ($error)#alerts error, assumes an opening script element exists, closes script element and exits
{	echo "alert ('".$error."');\n";
	echo "</script>\n";
	writeBody ();
	exit;
}
function createSelection ($Objects)
{	global $conf;
	foreach ($Objects as $Building => $value)
	{	echo '<div class="visible">'."\n";
		echo '<img src="'.$conf['Image_path'].'collapsed.gif" style="position:relative;top:3px;" />'."\n";
		echo '<span>'.$Building.'</span>'."\n";
		foreach ($value as $Rack => $value)
		{	echo '<div class="hidden">'."\n";
			echo '<img src="'.$conf['Image_path'].'collapsed.gif" style="position:relative;top:3px;" />'."\n";
			echo '<span>'.$Rack.'</span>'."\n";
			$checkall_ar = Array ();
			foreach ($value as $Section => $value)
			{	echo '<div class="hidden">'."\n";
				echo '<input id="'.$value[GUID].'" name="'.$value[GUID].'" type="checkbox">'."\n";
				echo '<span>'.$Section.'</span>'."\n";
				echo '</div>'."\n";
				$checkall_ar[] = $value[GUID];
			}
			if (count ($checkall_ar) > 2)
			{	echo '<div class="hidden">'."\n";
				echo '<input id="checkallbox" name="checkallbox" type="checkbox">'."\n";
				echo '<span>All</span>'."\n";
				echo '</div>'."\n";
			}
			echo '</div>'."\n";
		}
		echo '</div>'."\n";
	}
}
function ViewSections ($ViewSections, $snmp)
{	global $conf,$cache;
	foreach (array_unique (explode (',', $ViewSections)) as $GUID)
	{	$Ports = sqlStatement ('SELECT * FROM Ports, Maps, MapCoords, Sections WHERE Sections.GUID = "'.$GUID.'" AND Sections.GUID = Ports.SectionGUID AND Maps.MapId = Sections.MapId AND MapCoords.MapId = Sections.MapId AND MapCoords.PortId = Ports.PortId;') or echoError ($error);
		echo '<div style="display:inline;">';
		echo '<div id="'.$GUID.'" class="Section">';
		echo '<span ';
		if ($snmp) echo 'id="'.$Ports[0][BuildingId].'-'.$Ports[0][RackId].'-'.$Ports[0][SectionId].'"';
			else echo 'id="SectionLabel"';
		if ($snmp) echo ' class="SectionLabelLoading">loading...';
			else echo ' class="SectionLabel">'.$Ports[0][BuildingId].'-'.$Ports[0][RackId].'-'.$Ports[0][SectionId];
		echo '</span>';
		echo '<img src="'.$conf[Image_path].$Ports[0][BackgroundPic].'" GALLERYIMG="no"/>';
		foreach ($Ports as $port)
		{	echo '<div id="'.$port[PortId].'" class="Port"';
			echo ' style="top:'.$port[Top].';left:'.$port[Left].';">';
			echo '<img src="'.$conf[Image_path].$port[PortPic].'" />';
			echo '<span class="PortText" style="'.$port[TextStyle].';';
			echo '">';
			echo $port[PortId].'</span>';
			echo '</div>';
		}
		echo '</div>';
		echo '</div>';
	}
	if ($snmp) echo '<script src="createObjects.js.php?ViewSections='.$ViewSections.'"></script>';
}
function ViewTemplate ($template)
{	global $conf,$cache;
	$Ports = sqlStatement ('SELECT * FROM Maps, MapCoords WHERE Maps.MapId = "'.$template.'" AND MapCoords.MapId = Maps.MapId') or echoError ($error);
	echo '<div style="display:inline;">';
	echo '<div id="'.$GUID.'" class="Section">'."\n";
	echo "\t".'<span id="SectionLabel" class="SectionLabel"></span>'."\n";
	echo "\t".'<img src="'.$conf[Image_path].$Ports[0][BackgroundPic].'" />'."\n";
	foreach ($Ports as $port)
	{	echo "\t".'<div id="'.$port[PortId].'" class="Port"';
		echo ' style="top:'.$port[Top].';left:'.$port[Left].';">'."\n";
		echo "\t\t".'<img src="'.$conf[Image_path].$port[PortPic].'" />'."\n";
		echo "\t\t".'<span class="PortText" style="'.$port[TextStyle].';';
		echo '">';
		echo $port[PortId].'</span>'."\n";
		echo "\t".'</div>'."\n";
	}
	echo '</div>'."\n";
	echo '</div>';	
}
function addSection ($SectionGUID)
{	global $conf;
	$Ports = sqlStatement ('SELECT * FROM Ports, Maps, MapCoords, Sections WHERE Sections.GUID = "'.$SectionGUID.'" AND Sections.GUID = Ports.SectionGUID AND Maps.MapId = Sections.MapId AND MapCoords.MapId = Sections.MapId AND MapCoords.PortId = Ports.PortId;') or echoError ($error);
	echo '<span id="SectionLabel" style="visibility:hidden;width:16.5em;_width:auto;"';
	echo ' class="SectionLabel">'.$Ports[0][BuildingId].'-'.$Ports[0][RackId].'-'.$Ports[0][SectionId];
	echo '</span>';
	echo "\t".'<img src="'.$conf[Image_path].$Ports[0][BackgroundPic].'" GALLERYIMG="no"/>';
	foreach ($Ports as $port)
	{	echo "\t".'<div id="'.$port[PortId].'" class="Port"';
		echo ' style="top:'.$port[Top].';left:'.$port[Left].';">';
		echo "\t\t".'<img src="'.$conf[Image_path].$port[PortPic].'" />';
		echo "\t\t".'<span class="PortText" style="'.$port[TextStyle].';';
		echo '">';
		echo $port[PortId].'</span>';
		echo "\t".'</div>';
	}
}
function loadGroup($GroupId)
{	$query = 'SELECT * from GroupCoords Where GroupId = "'.$GroupId.'"';	
	$Group = sqlStatement ($query);
	foreach ($Group as $Section)
	{	echo '<div id="'.$Section[SectionGUID].'" class="addSection" style="top:'.$Section[Top].';left:'.$Section[Left].';" draggable="true">';
		addSection ($Section[SectionGUID]);
		echo '</div>';
	}
}
function viewGroup ($GroupId)
{	$query = 'SELECT * from GroupCoords Where GroupId = "'.$GroupId.'"';	
	$Group = sqlStatement ($query);
	foreach ($Group as $Section)
	{	echo '<div class="Group" style="position:absolute;top:'.$Section[Top].';left:'.$Section[Left].';">';
		ViewSections ($Section[SectionGUID], "getsnmp");
		echo '</div>';
	}
}
function get_section_SNMP ($Device)
{	global $conf;
	snmp_set_quick_print (1);
	$CommId_get = $Device[CommId_get];
	$int_timeout = $conf[snmp][int_timeout];
	$int_retries = $conf[snmp][int_retries];
	if ($CommId_get == '') $CommId_get = $conf[snmp][CommId_get];
	$snmp[system][sysDescr] = snmpget($Device[DeviceId], $CommId_get, $conf[oid][system][sysDescr], $int_timeout, $int_retries) or $snmp[system][sysDescr] = 'no response';
	if ($snmp[system][sysDescr] != 'no response')
	{	$snmp[system][sysDescr] = preg_replace ('/\A[A-Z]*\:||\r||\n||\'/', '',$snmp[system][sysDescr]);
		$tables = Array ('system','dot1dBasePortTable','dot1dTpFdbTable','dot1qPortVlanTable');
		foreach ($tables as $table)
		{	foreach ($conf[snmp][$table] as $Object => $value)
			{	if ($value == 'on')
				{	switch ($table)
					{	case 'system':
							if ($Object != 'sysDescr')
							{	$snmp[$table][$Object] = snmpget($Device[DeviceId], $CommId_get, $conf[oid][$table][$Object], $int_timeout, $int_retries);
							}
							break;
						case 'dot1dBasePortTable' or 'dot1dTpFdbTable':
							if ($Device[GetMacAddresses] == '')
							{	$snmp[$table][$Object] = snmpwalkoid($Device[DeviceId], $CommId_get, $conf[oid][$table][$Object], $int_timeout, $int_retries);
							}
							break;
						case 'dot1qPortVlanTable':
							if ($Device[GetVlans] == '')
							{	$snmp[$table][$Object] = snmpwalkoid($Device[DeviceId], $CommId_get, $conf[oid][$table][$Object], $int_timeout, $int_retries);
							}
					}
				}
			}
		}
		if ($Device[GetMacAddresses] == '')
		{	foreach ($snmp[dot1dBasePortTable][dot1dBasePortIfIndex] as $oid => $InterfaceId)
			{	$dot1dBasePortIfIndex =  substr ($oid, strpos ($oid,'17.1.4.1.2.', true) + 11);
				foreach ($snmp[dot1dTpFdbTable][dot1dTpFdbPort] as $decmac => $dot1dTpFdbPort)
				{	if ($dot1dTpFdbPort == $dot1dBasePortIfIndex)
					{	$hexmac = '';
						$decmac = substr ($decmac, strpos ($decmac,'17.4.3.1.2.', true) + 11);
						$octets = explode ('.',$decmac);
						for ($i=0;$i < 5; $i++) $hexmac .= dechex ($octets[$i]).':';
						$hexmac .= dechex ($octets[5]);
						$snmp[Ethernet][$InterfaceId] .= $hexmac.',';
					}
				}
			}
			$snmp[Ethernet] = preg_replace ('/\,\Z/','',$snmp[Ethernet]);
		}else
		{	# Include file for generating Mac addresses.
			# Must return an Array indexed by $InterfaceId.
			# Each $InterfaceId must contain a String of comma delimited Mac Addresses.
			# Example:  $Ethernet[868] = "0:1:23:4:56:78,0:9a:bc:d:e:f0"; return $Ethernet;
			$snmp[Ethernet] = include ($Device[GetMacAddresses]);
		}
		if ($Device[GetVlans] == '')
		{	foreach ($snmp[dot1qPortVlanTable][dot1qPvid] as $oid => $Vlan)
			{	$InterfaceId =  substr ($oid, strpos ($oid,'17.7.1.4.5.1.1.', true) + 15);
				$snmp[Vlan][$InterfaceId] = $Vlan;
			}
		}else
		{	# Include file for generating Vlans.
			# Must return an Array indexed by $InterfaceId.
			# Each $InterfaceId must contain a value for Vlan.
			# Example:  $Vlans[868] = "2, 34, 40"; return $Vlans;
			$snmp[Vlan] = include($Device[GetVlans]);
		}
		snmp_set_quick_print (0);
	}
		return $snmp;
}
function  get_port_snmp ($Device,$InterfaceId)
{	global $Cache,$conf,$ethersByAddr;
	snmp_set_quick_print (1);
	$CommId_get = $Device[CommId_get];
	$int_timeout = $conf[snmp][int_timeout];
	$int_retries = $conf[snmp][int_retries];
	if ($CommId_get == '') $CommId_get = $conf[snmp][CommId_get];
	if ($Cache[$Device[DeviceId]][system][sysDescr] != 'no response')
	{	foreach ($conf[snmp][ifEntry] as $Object => $val)
		{	if ($val == 'on')
			{	$snmp[ifEntry][$Object] = snmpget($Device[DeviceId], $CommId_get, $conf[oid][ifEntry][$Object].'.'.$InterfaceId, $int_timeout, $int_retries);
			}
		}
		$snmp[Vlan] = $Cache[$Device[DeviceId]][Vlan][$InterfaceId];
		$snmp[Ethernet] = $Cache[$Device[DeviceId]][Ethernet][$InterfaceId];
		$ethers = split (',', $snmp[Ethernet]);
		$count = count ($ethers);
		if ($conf[getHosts] == 'NIS')
		{	if(!$ethersByAddr) $ethersByAddr = yp_cat ($conf[NIS][Domain],'ethers.byaddr');
			$snmp[Ethernet] = '';
			foreach($ethers as $macaddr)
			{	$macaddr = preg_replace ('/\s/','',$macaddr);
				if ($ethersByAddr[$macaddr] and $macaddr != '') $snmp[Ethernet] .= '<div class=getHostInfo id='.$macaddr.' onclick=getHostInfo(this.id)>'.$ethersByAddr[$macaddr].'</div>';
				$snmp[Mac] = $macaddr;
			}
			$snmp[Ethernet] = preg_replace ('/\,\Z/','',$snmp[Ethernet]);
		}else
		{	# Include file for generating HostNames.
			# Must return a String of hosts in this format
			# $Host = "($Ethernet $HostName $IpAddress)"; return $Host;
			# Example: $Host = "(a:b:c:d:e:f patchmaker 27.0.0.1),(f:e:d:c:b:a portmaker 27.0.0.2)"; return $Host;
			if ($count > 0) $snmp[Ethernet] = include ($conf[getHosts]);
		}
		$snmp[Ethernet] = preg_replace ('/\,/',',<br />',$snmp[Ethernet]);
		snmp_set_quick_print (0);
	}
	return $snmp;
}
function showSearchResults ($sql)
{	global $conf;
	$counter = 1;
	for ($i = 0; $i < count ($sql); $i++)
	{	if ($sql[$i][View] == true)
		{	$counter++;
			$backcolor1 = '#f0f0f0';
			$backcolor2 = $conf[SidePanel][bgcolor];
			$rowcolor = ($counter % 2)? $backcolor2: $backcolor1;
			echo '<tr style="background-color:'.$rowcolor.';"';
			echo ' i="'.$i.'"><td nowrap="nowrap">&nbsp;<span class="found" onclick="location.replace(parent.parent.mainpanelURL + \'?ViewSections='.$sql[$i][GUID].'\')">'.$sql[$i][PortName].'</span></td>';
			echo '<td nowrap="nowrap">&nbsp;<span class="found" onclick="location.replace(parent.parent.mainpanelURL + \'?ViewSections='.$sql[$i][PatchSectionGUID].'\')">'.$sql[$i][PatchName].'</span></td>';
			echo '<td nowrap="nowrap">&nbsp;'.$sql[$i][RoomId].'</td>';
			echo '<td nowrap="nowrap">&nbsp;'.$sql[$i][ClassId].'</td>';
			echo '<td nowrap="nowrap">&nbsp;'.$sql[$i][InterfaceId].'</td>';
			echo '<td nowrap="nowrap">&nbsp;'.$sql[$i][DeviceId].'</td>';
			echo '</tr>'."\n";
		}
	}
}
function saveTemplate ($saveTemplate, $_GET)
{	$saveTemplate = strip ($saveTemplate);
	$PortCoords = strip ($_GET[PortCoords]);
	$BackgroundPic = strip ($_GET[BackgroundPic]);
	$PortPic  = strip ($_GET[PortPic]);
	$PortUpXPic = strip ($_GET[PortUpXPic]);
	$PortUpPic = strip ($_GET[PortUpPic]);
	$PortDownPic = strip ($_GET[PortDownPic]);
	$PatchMakePic = strip ($_GET[PatchMakePic]);
	$PortNoDevicePic = strip ($_GET[PortNoDevicePic]);
	$TextStyle = strip ($_GET[TextStyle]);
	$PortCoords = explode (';', $PortCoords);
	deleteTemplate ($saveTemplate);
	$query = 'INSERT INTO `Maps` VALUES ("'.$saveTemplate.'", "'.$BackgroundPic.'", "'.$PortPic.'", "'.$PortUpPic.'", "'.$PortDownPic.'", "'.$PortUpXPic.'", "'.$PatchMakePic.'", "'.$PortNoDevicePic.'", "'.$TextStyle.'");';
	sqlStatement ($query);
	foreach ($PortCoords as $Coords)
	{	list ($id, $left, $top) = split (',', $Coords);
		if ($id != '' and $left != '' and $top != '')
		{	$query = 'INSERT INTO `MapCoords` VALUES ("'.$saveTemplate.'", "'.$id.'", "'.$top.'", "'.$left.'", "0");';
			sqlStatement ($query);
		}
	}
}
function saveGroup  ($saveGroup, $_GET)
{	$saveGroup = strip ($saveGroup);
	$Coords = strip ($_GET[Coords]);
	$Coords = explode (';', $Coords);
	deleteGroup ($saveGroup);
	$query = 'INSERT INTO `Groups` VALUES ("'.$saveGroup.'");';
	sqlStatement ($query);
	foreach ($Coords as $coords)
	{	list ($id, $left, $top) = split (',', $coords);
		if ($id != '' and $left != '' and $top != '')
		{	$query = 'INSERT INTO `GroupCoords` VALUES ("'.$saveGroup.'", "'.$id.'", "'.$top.'", "'.$left.'");';
			sqlStatement ($query);
		}
	}
}
function deleteGroup ($deleteGroup)
{	$deleteGroup = strip ($deleteGroup);
	sqlStatement ("DELETE FROM `Groups` WHERE `GroupId` = '".$deleteGroup."';");
	sqlStatement ("DELETE FROM `GroupCoords` WHERE `GroupId` = '".$deleteGroup."';");
}
function deleteTemplate ($deleteTemplate)
{	$deleteTemplate = strip ($deleteTemplate);
	sqlStatement ("DELETE FROM `MapCoords` WHERE `MapId` = '".$deleteTemplate."';");
	sqlStatement ("DELETE FROM `Maps` WHERE `MapId` = '".$deleteTemplate."';");
}
function saveSection ($_GET)
{	$Building = strip ($_GET[Building]);
	$Rack  = strip ($_GET[Rack]);
	$Section = strip ($_GET[Section]);
	$Template = strip ($_GET[Template]);
	$DeviceId = strip ($_GET[DeviceId]);
	$Slot = strip ($_GET[Slot]);
	$StartingInterface = strip ($_GET[StartingInterface]);
	$CommGet = strip ($_GET[CommGet]);
	$CommSet = strip ($_GET[CommSet]);
	$GetMacAddresses = strip ($_GET[GetMacAddresses]);
	$GetVlans = strip ($_GET[GetVlans]);
	$Ports = sqlStatement ("SELECT * FROM `MapCoords` WHERE `MapId` = '".$Template."';");
	deleteSection ($_GET);
	$query = 'INSERT INTO `Sections` VALUES ("", "'.$Building.'", "'.$Rack.'", "'.$Section.'", "'.$Template.'", "'.$DeviceId.'", "'.$Slot.'", "'.$StartingInterface.'", "'.count($Ports).'", "'.$CommGet.'", "'.$CommSet.'", "'.$GetMacAddresses.'", "'.$GetVlans.'");';
	sqlStatement ($query);
	$query = 'SELECT GUID FROM `Sections` WHERE `BuildingId` = "'.$Building.'" AND RackId = "'.$Rack.'" AND SectionId = "'.$Section.'" LIMIT 1;';
	$GUID = sqlStatement ($query);
	$GUID = $GUID[GUID];
	foreach ($Ports as $port)
	{	$query = 'INSERT INTO `Ports` VALUES ("'.$GUID.'", "'.$port[PortId].'", "0", "0", "", "", "", "");';
		sqlStatement ($query);
	}
	return $GUID;
}
function deleteSection ($_GET)
{	$Building = strip ($_GET[Building]);
	$Rack  = strip ($_GET[Rack]);
	$Section = strip ($_GET[Section]);
	$query = 'SELECT GUID FROM `Sections` WHERE `BuildingId` = "'.$Building.'" AND RackId = "'.$Rack.'" AND SectionId = "'.$Section.'" LIMIT 1;';
	$GUID = sqlStatement ($query);
	$GUID = $GUID[GUID];
	sqlStatement ("DELETE FROM `Sections` WHERE `GUID` = '".$GUID."';");
	sqlStatement ("DELETE FROM `Ports` WHERE `SectionGUID` = '".$GUID."';");
	sqlStatement ('UPDATE `Ports` SET `PatchSectionGUID` = "0", `PatchPortId` = "0" WHERE `PatchSectionGUID` = "'.$GUID.'";');
	return $GUID;
}
function strip ($string)
{	return preg_replace ('/\/|\\\|\'|\"/', '', $string);
}
function validatePrivilege ($user, $privilege)
{	global $conf;
	$umask = sqlStatement ('SELECT `UMask` From `Users` WHERE `UID` = "'.$user.'" LIMIT 1');
	$privilege = $conf['privilege'][$privilege];
	if (($privilege & $umask['UMask']))
	{	return true;
	}
	else return false;
}
function createUser ($createUser)
{?>	<div style="position:relative;margin:10px;">Username: <input id="UID" type="text" value="<?php echo $createUser;?>" /></div>
	<table width="120px" style="position:relative;margin-left:10px;" cellspacing="0px" cellpadding="0px">
	<tr><td align="center" bgcolor="#f0f0f0">Privileges</td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">Create: <input id="Create" type="checkbox" class="privileges" checked="checked" value="1"/></td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">Search:<input id="Search" type="checkbox" class="privileges" checked="checked" value="2"/></td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">Help:<input id="Help" type="checkbox" class="privileges" checked="checked" value="4"/></td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">Port Menu:<input id="portmenu" type="checkbox" class="privileges" checked="checked" value="8"/></td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">Update Room:<input id="UpdateRoom" type="checkbox" class="privileges" checked="checked" value="16"/></td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">Comment:<input id="SetComment" type="checkbox" class="privileges" checked="checked" value="32"/></td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">Update Class:<input id="UpdateClass" type="checkbox" class="privileges" checked="checked" value="64"/></td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">Add Patch:<input id="AddPatch" type="checkbox" class="privileges" checked="checked" value="128"/></td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">Delete Patch:<input id="DeletePatch" type="checkbox" class="privileges" checked="checked" value="256"/></td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">Enable Port:<input id="EnablePort" type="checkbox" class="privileges" checked="checked" value="512"/></td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">Disable Port:<input id="DisablePort" type="checkbox" class="privileges" checked="checked" value="1024"/></td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">Set Vlan:<input id="SetVlan" type="checkbox" class="privileges" checked="checked" value="2048"/></td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">View MRTG:<input id="ViewMRTG" type="checkbox" class="privileges" checked="checked" value="4096"/></td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">View InMon:<input id="ViewInMon" type="checkbox" class="privileges" checked="checked" value="8192"/></td></tr>
	<tr><td align="right" bgcolor="#d0e0ff">Admin:<input id="Admin" type="checkbox" class="privileges" checked="checked" value="16384"/></td></tr>
	</table>
<?php
}
function loadUser ($loadUser)
{	echo '<div style="position:relative;margin:10px;">Username: <input id="UID" type="text" value="'.$loadUser.'" /></div>';
	echo '<table width="120px" style="position:relative;margin-left:10px;" cellspacing="0px" cellpadding="0px">';
	echo '<tr><td align="center" bgcolor="#f0f0f0">Privileges</td></tr>';
	echo '<tr><td align="right" bgcolor="#d0e0ff">Create: <input id="Create" type="checkbox" class="privileges" value="1"';
	if (validatePrivilege ($loadUser, 'Create')) echo ' checked="checked";';
	echo '/></td></tr><tr><td align="right" bgcolor="#d0e0ff">Search:<input id="Search" type="checkbox" class="privileges" value="2"';
	if (validatePrivilege ($loadUser, 'Search')) echo ' checked="checked";';
	echo '/></td></tr><tr><td align="right" bgcolor="#d0e0ff">Help:<input id="Help" type="checkbox" class="privileges" value="4"';
	if (validatePrivilege ($loadUser, 'Help')) echo ' checked="checked";';
	echo '/></td></tr><tr><td align="right" bgcolor="#d0e0ff">Port Menu:<input id="portmenu" type="checkbox" class="privileges" value="8"';
	if (validatePrivilege ($loadUser, 'portmenu')) echo ' checked="checked";';
	echo '/></td></tr><tr><td align="right" bgcolor="#d0e0ff">Update Room:<input id="UpdateRoom" type="checkbox" class="privileges" value="16"';
	if (validatePrivilege ($loadUser, 'UpdateRoom')) echo ' checked="checked";';
	echo '/></td></tr><tr><td align="right" bgcolor="#d0e0ff">Comment:<input id="SetComment" type="checkbox" class="privileges" value="32"';
	if (validatePrivilege ($loadUser, 'SetComment')) echo ' checked="checked";';
	echo '/></td></tr><tr><td align="right" bgcolor="#d0e0ff">Update Class:<input id="UpdateClass" type="checkbox" class="privileges" value="64"';
	if (validatePrivilege ($loadUser, 'UpdateClass')) echo ' checked="checked";';
	echo '/></td></tr><tr><td align="right" bgcolor="#d0e0ff">Add Patch:<input id="AddPatch" type="checkbox" class="privileges" value="128"';
	if (validatePrivilege ($loadUser, 'AddPatch')) echo ' checked="checked";';
	echo '/></td></tr><tr><td align="right" bgcolor="#d0e0ff">Delete Patch:<input id="DeletePatch" type="checkbox" class="privileges" value="256"';
	if (validatePrivilege ($loadUser, 'DeletePatch')) echo ' checked="checked";';
	echo '/></td></tr><tr><td align="right" bgcolor="#d0e0ff">Enable Port:<input id="EnablePort" type="checkbox" class="privileges" value="512"';
	if (validatePrivilege ($loadUser, 'EnablePort')) echo ' checked="checked";';
	echo '/></td></tr><tr><td align="right" bgcolor="#d0e0ff">Disable Port:<input id="DisablePort" type="checkbox" class="privileges" value="1024"';
	if (validatePrivilege ($loadUser, 'DisablePort')) echo ' checked="checked";';
	echo '/></td></tr><tr><td align="right" bgcolor="#d0e0ff">Set Vlan:<input id="SetVlan" type="checkbox" class="privileges" value="2048"';
	if (validatePrivilege ($loadUser, 'SetVlan')) echo ' checked="checked";';
	echo '/></td></tr><tr><td align="right" bgcolor="#d0e0ff">View MRTG:<input id="ViewMRTG" type="checkbox" class="privileges" value="4096"';
	if (validatePrivilege ($loadUser, 'ViewMRTG')) echo ' checked="checked";';
	echo '/></td></tr><tr><td align="right" bgcolor="#d0e0ff">View InMon:<input id="ViewInMon" type="checkbox" class="privileges" value="8192"';
	if (validatePrivilege ($loadUser, 'ViewInMon')) echo ' checked="checked";';
	echo '/></td></tr><tr><td align="right" bgcolor="#d0e0ff">Admin:<input id="Admin" type="checkbox" class="privileges" value="16384"';
	if (validatePrivilege ($loadUser, 'Admin')) echo ' checked="checked";';
	echo '/></td></tr></table>';
}
function saveUser ($saveUser, $UMask)
{	deleteUser ($saveUser);
	$query = 'INSERT INTO `Users` VALUES ("'.$saveUser.'", "'.$UMask.'");';
	sqlStatement ($query);
	echo "<script>alert ('".$saveUser." has been saved.');</script>";
	loadUser ($saveUser);
}
function deleteUser ($deleteUser)
{	$query = 'DELETE FROM `Users` WHERE `UID` = "'.$deleteUser.'";';
	sqlStatement ($query);
}
function getSectionFromLogs ($GUID)
{	$query = 'SELECT * FROM Log WHERE Event = "SaveSection" AND SectionGUID = "'.$GUID.'" LIMIT 1;';
	$section = sqlStatement ($query);
	$SectionName = preg_replace ('/\Adevice |\Apanel /', '', $section[Value]);
	return $SectionName;
}
?>
